#lang racket

(require redex "grammar.rkt")

(provide (all-defined-out))

(define-relation gadt-lang
  [(C . ⊨ . [^ FF_1 FF_2 FF ...])
   (C . ⊨ . [^ FF_1]) (C . ⊨ . [^ FF_2]) (∧ (C . ⊨ . [^ FF]) ...)]
  [(C . ⊨ . [^])]
  [([^ CC_1 ... DD CC_2 ...] . ⊨ . [^ DD])]
  [(C . ⊨ . [^ (τ ~ τ)])]
  [(C . ⊨ . [^ ((T τ ...) ~ (T υ ...))])
   (≈ (τ ...) (υ ...))
   (∧ (C . ⊨ . [^ (τ ~ υ)]) ...)]
  [(C . ⊨ . [^ (∀ [α ...] (b ...) D ⊃ F)]) ((& C D) . ⊨ . F) (≡ (∩ {b ...} (fv C)) {})]
  [((name C (^ CC ... ((T τ ...) ~ (T υ ...)) DD ...)) . ⊨ . F)
   (≈ (τ ...) (υ ...))
   ((& [^ (τ ~ υ) ...] C) . ⊨ . F)]
  [((name C (^ CC ... (τ ~ υ) DD ...)) . ⊨ . F)
   ((& [^ (υ ~ τ)] C) . ⊨ . F)]
  [((name C (^ CC_1 ... (τ_1 ~ τ_2) CC_2 ... (τ_2 ~ τ_3) CC_3 ...)) . ⊨ . F)
   ((& [^ (τ_1 ~ τ_3)] C) . ⊨ . F)]
  [((name C (^ CC_1 ... (τ_2 ~ τ_3) CC_2 ... (τ_1 ~ τ_2) CC_3 ...)) . ⊨ . F)
   ((& [^ (τ_1 ~ τ_3)] C) . ⊨ . F)]
  )

(define-relation gadt-lang
  ;; not complete (does not look for unifier)
  [(consistent C) (⊨ [^] C)])

(define (test-entailment)
  (redex-test-suite
  
    (test-equal (term (⊨ [^ (a ~ b)] [^ (a ~ b)])) #t)
    (test-equal (term (⊨ [^ (a ~ b)] [^ (b ~ a)])) #t)))
